From cd3b70b5220db284ab38e009f37b8e5924021f00 Mon Sep 17 00:00:00 2001
From: Pierre-Yves Chibon <pingou@pingoured.fr>
Date: Feb 09 2016 16:38:48 +0000
Subject: [PATCH 280/1001] Rework the pagure widget for open PR


- Adjust the HTML to be more consistent with the layout in pagure itself
and use the entire container.
- Include the project name since at the end we want to be able to list
Open PRs for multiple projects hosted on pagure.
- Change the title a little to not mis-lead that the PR are on pagure not
necessarily about pagure

---

diff --git a/hubs/widgets/pagure_pr.py b/hubs/widgets/pagure_pr.py
index f041113..2c5207e 100644
--- a/hubs/widgets/pagure_pr.py
+++ b/hubs/widgets/pagure_pr.py
@@ -4,48 +4,66 @@ import jinja2
 import requests
 from hubs.widgets.base import argument
 import hubs.validators as validators
-chrome = panel("Pagure: Newest Open Pull Requests")
+chrome = panel("Newest Open Pull Requests on Pagure")
 
 pagure_url = "https://pagure.io/api/0"
 
 template = jinja2.Template("""
   <div class="container">
-    {% for i in range(0,total_req) %}
-      <div>
-        <table class="table-responsive table-condensed">
-          <tr>
-            <td valign="top" class="panel-heading">
-              <img src="{{ url_for(
-                  'static', filename='img/pagure_logo.png')
-                }}" alt="Pagure logo" />
-              <b>#{{ all_pr[i]['pr_id'] }}</b>
-            </td>
-            <td width="260px">
-              <b>{{ all_pr[i]['pr_title'] }} ...</b>
-            </td>
-          </tr>
-         </table>
-       <table class="table-responsive table-condensed">
-          <tr>
-            <td width="280px" >
-              <font size="2">
-                <i>Opened by <a href="https://pagure.io/user/{{ all_pr[i]['pr_openedby'] }}" target="_blank">{{ all_pr[i]['pr_openedby'] }}</a>
-                {% if all_pr[i]['pr_assignee'] %}
-                  <br>Assigned to <a href="https://pagure.io/user/{{ all_pr[i]['pr_assignee'] }}" target="_blank">{{ all_pr[i]['pr_assignee'] }}</a></i>
-                {% endif %}
-              </font>
-            </td>
-            <td>
-              <a href="https://pagure.io/{{ repo }}/pull-request/{{ all_pr[i]['pr_id'] }}" target="_blank">
-                <button type="button" class="btn btn-default" aria-label="Left Align">
-                  <span class="glyphicon glyphicon-chevron-right" aria-hidden="true"></span>
-                </button>
+    <table id="pagure-issues-list" class="table table-hover table-striped m-b-0">
+      <thead class="thead-default">
+        <tr>
+          <th id="pr-title">Project</th>
+          <th id="pr-title">Pull-Request</th>
+          <th class="open_by">Reporter</th>
+          <th class="assigned">Assignee</th>
+        </tr>
+      </thead>
+      <tfoot>
+      </tfoot>
+      <tbody>
+        {% for pr in all_pr %}
+        <tr>
+          <td>
+            {% if pr['pr_project_user'] %}
+            <a href="https://pagure.io/forks/{{
+                pr['pr_project_user'] }}/{{ pr['pr_project_name'] }}"
+              target="_blank">
+              {{ pr['pr_project_user'] }}/{{ pr['pr_project_name'] }}
+            {% else %}
+            <a href="https://pagure.io/{{ pr['pr_project_name'] }}"
+              target="_blank">
+              {{ pr['pr_project_name'] }}
+            {% endif %}
+            </a>
+          </td>
+          <td>
+            <span class="label label-default">#{{ pr['pr_id'] }}</span>
+            <a href="https://pagure.io/{{ repo }}/pull-request/{{ pr['pr_id'] }}"
+                target="_blank">
+              {{ pr['pr_title'] }} ...
+            </a>
+          </td>
+          <td>
+            <a href="https://pagure.io/user/{{ pr['pr_openedby'] }}"
+                target="_blank">
+              {{ pr['pr_openedby'] }}
+            </a>
+          </td>
+          <td>
+            {% if pr['pr_assignee'] %}
+              <a href="https://pagure.io/user/{{ pr['pr_assignee'] }}"
+                  target="_blank">
+                {{ pr['pr_assignee'] }}
               </a>
-            </td>
-          </tr>
-        </table>
-      </div>
-    {%endfor%}
+            {% else %}
+              <span class="text-muted">unassigned</span>
+            {% endif %}
+          </td>
+        </tr>
+        {% endfor %}
+      </tbody>
+    </table>
     </div class="row">
       <center><a href="https://pagure.io/{{ repo }}/pull-requests" target="_blank">All Pull-Requests</a><center>
     </div>
@@ -63,16 +81,22 @@ def data(session, widget, repo):
     data = response.json()
     total_req = data['total_requests']
     all_pr = list()
-    for i in range(0,total_req):
+    for i in range(0, total_req):
+        pr_project_user = None
+        if data['requests'][i]['project']['parent']:
+            pr_project_user = data['requests'][i]['project']['user']['username']
+
         all_pr.append(
             dict(
+                  pr_project_name=data['requests'][i]['project']['name'],
+                  pr_project_user=pr_project_user,
                   pr_id=data['requests'][i]['id'],
                   pr_title=data['requests'][i]['title'][:45],
                   pr_openedby=data['requests'][i]['user']['name'],
                   pr_assignee=data['requests'][i]['assignee'],
             )
         )
-    all_pr.reverse()
+
     return dict(
         all_pr=all_pr,
         total_req=total_req,

